/contador hasta mil con pulsador y pulsador reset


/ * MAPEO DE PUERTO EN ARDUINO
/ * 0 PORTB 0X05
/ * 1 PORTC 0X08
/ * 2 PORTD 0X0B
/ * 3 PINB 0X03
/ * 4 PINC 0X06
/ * 5 PIND 0X09
/ * 6 DDRB 0X04
/ * 7 DDRC 0X07
/ * 8 DDRD 0X0A


$LCDPORT 2
$ENTRADA 4


$ALMACENB 240
$TMP 241

$NUM1 242
$NUM2 243


#SETUP

/puertos como salida	para el LCD
 MOV N,R0$252
 OUT N$008

/puerto C como entrada
 MOV N,R0$000
 OUT N$007

 CALL N#LCD_INIT

/ para ganar espacio se sustituye la rutina 
/	call #lcd_cls		
 MOV N,R0$001
 CALL N#SENDI

#RESET
 MOV N,R0$048
 MOV R0,(N)$242
 MOV R0,(N)$243
 JMP N#PRINT

#VOLVER:
#UNO
 IN N$004
 AND N$002
 CMP N$002
 JZ N#RESET

 WAIT N$050
 IN N$004
 AND N$001
 CMP N$001
 JZ N#UNO

#DOS
 IN N$004
 AND N$002
 CMP N$002
 JZ N#RESET

 WAIT N$050
 IN N$004
 AND N$001
 CMP N$000
 JZ N#DOS


#INCRE
 MOV N,R3$243
 MOV (R3),R0
 INC R0
 MOV R0,(R3)
 CMP N$058
 JNZ N#PRINT
 MOV N,R0$048
 MOV R0,(R3)

 DEC R3
 MOV (R3),R0
 INC R0
 MOV R0,(R3)
 CMP N$058
 JNZ N#PRINT
 MOV N,R0$048
 MOV R0,(R3)


#PRINT
/	mov 1,r0
/	call #lcd_at
 MOV N,R0$129
 CALL N#SENDI

 MOV N,R3$242
 MOV (R3),R0
 CALL N#SENDCHAR

 INC R3
 MOV (R3),R0
 CALL N#SENDCHAR

 JMP N#VOLVER:



/#lcd_cls
/	mov 1,r0
/	call #sendi
/	ret

/R0 lugar en el LCD	
/#lcd_at				
/	or 128
/	call #sendi
/	ret


/Inicializar  valores 3,3,3,2, 40,12,1,6
#LCD_INIT
 WAIT N$250
#VOLVER
 CALL N#DATO0
 CALL N#ENABLE0

 MOV N,R0$003
 CALL N#PON4BITS
 CALL N#PON4BITS
 CALL N#PON4BITS
 DEC R0
 CALL N#PON4BITS
 CALL N#DATO0

 MOV N,R0$040
 CALL N#SENDI
 MOV N,R0$012
 CALL N#SENDI
 MOV N,R0$001
 CALL N#SENDI
 MOV N,R0$006
 CALL N#SENDI

 RET

/datos de control pasados en r0
#SENDI
 CALL N#DATO0
 CALL N#SENDCHAR
 WAIT N$003
 CALL N#DATO1
 RET

/ char pasado en R0
#SENDCHAR
 PUSH R0
 MOV R0,(N)$241
 RR N$004
 CALL N#PON4BITS
 MOV (N),R0$241
 CALL N#PON4BITS
 POP R0
 RET

#ENABLE
 CALL N#ENABLE0
 WAIT N$003
 CALL N#ENABLE1
 WAIT N$003
 CALL N#ENABLE0
 WAIT N$003
 RET


/parametro pasado en R0
#PON4BITS
 PUSH R1
 PUSH R0
 AND N$015
 RL N$002
 MOV R0,R1
 MOV (N),R0$240
 AND N$195
 OR R1,R0
 MOV R0,(N)$240
 OUT N$002
 CALL N#ENABLE
 POP R0
 POP R1
 RET


#DATO1
 PUSH R0
 MOV (N),R0$240
 OR N$128
 MOV R0,(N)$240
 OUT N$002
 POP R0
 RET

#DATO0
 PUSH R0
 MOV (N),R0$240
 AND N$127
 MOV R0,(N)$240
 OUT N$002
 POP R0
 RET

#ENABLE1
 PUSH R0
 MOV (N),R0$240
 OR N$064
 MOV R0,(N)$240
 OUT N$002
 POP R0
 RET

#ENABLE0
 PUSH R0
 MOV (N),R0$240
 AND N$191
 MOV R0,(N)$240
 OUT N$002
 POP R0
 RET

#FIN

 STOP
 END


