#include <stdio.h>
#include <stdlib.h>

#include <string.h>


#define LINEMAX 100
#define VARMAX 100
                       

struct VARIABLES { char nombre[12]; int valor; };
struct VARIABLES variables[VARMAX];
int nvariables;


FILE *pf, *pfasm;
char lineaE[LINEMAX];
char lineaEe[LINEMAX];

char etiqueta[20]="";
int indice;

//----------------------------------------------

static char *codigoN[]={ "0", "MOV R0,R0", "1", "MOV R0,R1", "2", "MOV R0,R2","3","MOV R0,R3",
                         "4", "MOV R1,R0", "5", "MOV R1,R1", "6", "MOV R1,R2","7","MOV R1,R3",
                         "8", "MOV R2,R0", "9", "MOV R2,R1", "10", "MOV R2,R2","11","MOV R2,R3",
                         "12", "MOV R3,R0", "13", "MOV R3,R1", "14", "MOV R3,R2","15","MOV R3,R3",
                         "16", "MOV (R0),R0", "17", "MOV (R0),R1", "18", "MOV (R0),R2","19","MOV (R0),R3",
                         "20", "MOV (R1),R0", "21", "MOV (R1),R1", "22", "MOV (R1),R2","23","MOV (R1),R3",
                         "24", "MOV (R2),R0", "25", "MOV (R2),R1", "26", "MOV (R2),R2","27","MOV (R2),R3",
                         "28", "MOV (R3),R0", "29", "MOV (R3),R1", "30", "MOV (R3),R2","31","MOV (R3),R3",
                         "32", "MOV R0,(R0)", "33", "MOV R0,(R1)", "34", "MOV R0,(R2)","35","MOV R0,(R3)",
                         "36", "MOV R1,(R0)", "37", "MOV R1,(R1)", "38", "MOV R1,(R2)","39","MOV R1,(R3)",
                         "40", "MOV R2,(R0)", "41", "MOV R2,(R1)", "42", "MOV R2,(R2)","43","MOV R2,(R3)",
                         "44", "MOV R3,(R0)", "45", "MOV R3,(R1)", "46", "MOV R3,(R2)","47","MOV R3,(R3)",

                         "48", "CMP R0,R0", "49", "CMP R0,R1", "50", "CMP R0,R2","51","CMP R0,R3",
                         "52", "CMP R1,R0", "53", "CMP R1,R1", "54", "CMP R1,R2","55","CMP R1,R3",
                         "56", "CMP R2,R0", "57", "CMP R2,R1", "58", "CMP R2,R2","59","CMP R2,R3",
                         "60", "CMP R3,R0", "61", "CMP R3,R1", "62", "CMP R3,R2","63","CMP R3,R3",

                         "64", "ADD R0,R0", "65", "ADD R0,R1", "66", "ADD R0,R2","67","ADD R0,R3",
                         "68", "ADD R1,R0", "69", "ADD R1,R1", "70", "ADD R1,R2","71","ADD R1,R3",
                         "72", "ADD R2,R0", "73", "ADD R2,R1", "74", "ADD R2,R2","75","ADD R2,R3",
                         "76", "ADD R3,R0", "77", "ADD R3,R1", "78", "ADD R3,R2","79","ADD R3,R3",

                         "96", "SUB R0,R0", "97", "SUB R0,R1", "98", "SUB R0,R2","99","SUB R0,R3",
                         "100", "SUB R1,R0", "101", "SUB R1,R1", "102", "SUB R1,R2","103","SUB R1,R3",
                         "104", "SUB R2,R0", "105", "SUB R2,R1", "106", "SUB R2,R2","107","SUB R2,R3",
                         "108", "SUB R3,R0", "109", "SUB R3,R1", "110", "SUB R3,R2","111","SUB R3,R3",


                         "128","PUSH R0","129","PUSH R1","130","PUSH R2","131","PUSH R3",
                         "132","POP R0","133","POP R1","134","POP R2","135","POP R3",
                         "136","INV R0","137","INV R1","138","INV R2","139","INV R3",
                         "140","CLEAR R0","141","CLEAR R1","142","CLEAR R2","143","CLEAR R3",

                         "148","MOV (R1+),R0", "149", "MOV R0,(R2+)","150", "MOV (R1+),(R2+)", "156", "AND R1,R0", "157","OR R1,R0", "158", "XOR R1,R0",

                         "160","MOV R0,PC", "161", "MOV R0,SP", "162","MOV R0,RI" ,"163", "MOV R0,RE",
                         "164","ENABLE I","165","DISABLE I","166","ENABLE E","167","DISABLE E",
                         "168", "RET","169", "NOP", "170", "STOP",
                         "174","IN (R1),R0","175","OUT R0,(R1)",

                         "176", "INC R0", "177" , "INC R1", "178", "INC R2", "179", "INC R3",
                         "180", "DEC R0", "181" , "DEC R1", "182", "DEC R2", "183", "DEC R3",

                         "999", "END","1000", "#", };

static char *codigoN2[]={ "192","CALL N", "193", "JMP N","194", "JZ N","195", "JNZ N",
                         "196", "JC N", "197", "JNC N", "198","JS N", "199","JNS N",
                         "200", "RL N","201","RR N","202","AND N","203","OR N",
                         "204","XOR N", "205","IN N", "206", "OUT N",

                         "208", "MOV N,R0",   "209","MOV N,R1",    "210","MOV N,R2",    "211", "MOV N,R3",
                         "212", "MOV (N),R0", "213", "MOV (N),R1", "214", "MOV (N),R2", "215", "MOV (N),R3",
                         "216", "MOV R0,(N)", "217", "MOV R1,(N)", "218", "MOV R2,(N)", "219", "MOV R3,(N)",
                         "220", "WAIT N",
                         "999", "END","1000", "#", };

static char *codigoSalto[]={"192","CALL N", "193", "JMP N","194", "JZ N","195", "JNZ N",
							"196", "JC N", "197", "JNC N", "198","JS N", "199","JNS N",
							"999", "END","1000", "#",};                         


void printError(void);
int changeSrt(char *cadena, char *busqueda, char *cambio);

int loadCodigo(char *nombre);
int disamble(int modo);

int buscaN1(int code);
int buscaN2(int code);
int buscaSalto(int code);

char fileOut[20]="file.asm";


unsigned char codigo[256];

int tipePrint=0;
int linea;


int main(int arg,char *argv[])
{
 int z;
 
    printf("\nDesamblador core8 V3_5\n=======================\n");
    if(arg<2)
		{
        printf("ERROR Debes incluir fichero.bin\n");
        printf("Formato:  disam fichero.bin \n");
        printf("\t\t-pt Salida por pantalla\n");
        printf("\t\t-o nombre fichero asm\n");

        return(-1);
		}
	for(z=1;z<arg;z++)
		 {
		  if( !strcmp(argv[z],"-pt"))  { tipePrint=1;}
		  if( !strcmp(argv[z],"-o"))  { sprintf(fileOut,"%s",argv[z+1]); z++;}
		 }
    
    loadCodigo(argv[1]);
	disamble(0);  //detecta saltos
	//for(z=0;z<nvariables;z++) printf("/Saltos%03d\n",variables[z].valor );
	disamble(1);  //imprime codigo
  
    printf("\n");
    return(0);
}

int buscaSalto(int code)
{
 int z;
	for(z=0;z<1000;z+=2)
		{
			 if( !strcmp(codigoSalto[z+1],"#") )     { break;  }
			 if( code==atoi(codigoSalto[z]) ) 	{ return(z); }
		}
	return(-1);
}

int buscaN1(int code)
{
 int z;
	for(z=0;z<1000;z+=2)
		{
			 if( !strcmp(codigoN[z+1],"#") )     { break;  }
			 if( code==atoi(codigoN[z]) ) 	{ return(z+1); }
		}
	return(-1);
}
 
int buscaN2(int code)
{
 int z;
	for(z=0;z<1000;z+=2)
		{
			 if( !strcmp(codigoN2[z+1],"#") )     { break;  }
			 if( code==atoi(codigoN2[z]) ) return(z+1);
		}
	return(-1);
}


 
int disamble(int modo)
{
 int coi,c,c2,z;
 char buffer[20];
	linea=0; 
	if(modo==0)
		{ nvariables=0;}
	 else
		{
			pfasm=fopen(fileOut,"w");
			if(pfasm==NULL){ printf("ERROR abriendo fichero %s \n",fileOut); return(-1);  }
			printf("\n");
		}	
	
	for(coi=0;coi<256;coi++)
		{
			c=codigo[coi];
			c2=codigo[coi+1];
			
			if(modo==0)
				{
				 if(-1!=buscaSalto(c) )   
					{ 
						variables[nvariables].valor=c2; 
						nvariables++;	
					}
				}
			if(modo==1)
				{
					for(z=0;z<nvariables;z++)
						{
						 if(coi==variables[z].valor ) 
							{
								if(tipePrint==1)printf("/DIREC_%03d\n",coi);
								fprintf(pfasm,"/DIREC_%03d\n",coi);	
							}
						}
				}
			
			z=buscaN1(c);
			if( -1==z )
				{
					z=buscaN2(c);
					if( -1==z )
						{return(-1);}
						else
						{
							sprintf(buffer," %03d",c2);							
							sprintf(lineaE,"%03u  %03u %03u\t%s",coi,c,c2,codigoN2[z]);
							sprintf(lineaEe,"        %s",codigoN2[z]);
							if(0==changeSrt(lineaE," N",buffer) )
									{
										sprintf(buffer,"(%03d)",c2);
										changeSrt(lineaE,"(N)",buffer);
									}
							if(0==changeSrt(lineaEe," N",buffer) )
									{
										sprintf(buffer,"(%03d)",c2);
										changeSrt(lineaEe,"(N)",buffer);
									}
							coi++;
						}
				}
				else
				{				 
				 sprintf(lineaE,"%03u  %03u   \t%s",coi,c,codigoN[z]);
				 sprintf(lineaEe,"        %s",codigoN[z]);		
				}
		 if(modo!=0)
			{
				if(tipePrint==1)printf("%s\n",lineaE);
				fprintf(pfasm,"%s\n",lineaEe);					
			}
		 if(c==170) break;	
		}
		
		if(modo!=0)	
			{ 
				fprintf(pfasm,"        END\n\n");
				fclose(pfasm); 
				printf("Ensamblado en fichero %s\n",fileOut); 
			}

 return(1);	
}
 
 
 
 
void printError(void)
{
     printf(" ****ERROR  %03i %s\n",linea-1,lineaE);
}


int loadCodigo(char *nombre)
{
 int z;
 FILE *pf;
	 printf("Cargando fichero %s \n",nombre); 
	 pf=fopen(nombre,"r");
	 if(pf==NULL){ printf("ERROR abriendo fichero  %s \n",nombre); return(-1);    }
	 for(z=0;z<256;z++)
		 {
			codigo[z]=fgetc(pf);
			//printf("%d ",codigo[z]);
		 }
	 fclose(pf);
	 return(0);
}


int changeSrt(char *cadena, char *busqueda, char *cambio)
{
 char *pu;
 int z,zz,i;
 int taBusqueda;
 char bufferS[LINEMAX];
 
		taBusqueda=strlen(busqueda); if(taBusqueda==0) return(0);
		pu=strstr(cadena,busqueda);
		if( pu==NULL )
				{ return(0);}
			else
				{
				 z=pu-cadena;
				 for(i=0;i<LINEMAX && i<z;i++) { bufferS[i]=cadena[i];}
				 for(zz=0;i<LINEMAX ;i++,zz++) {  bufferS[i]=cambio[zz]; if(cambio[zz]==0)break;}
				 z+=taBusqueda;
				 for(;i<LINEMAX ;i++,z++){ bufferS[i]=cadena[z]; if(cadena[z]==0)break; }
				 bufferS[LINEMAX-1]=0;
				 strcpy(cadena,bufferS);	
				}
 return(1);	
}	
