/contador hasta mil con pulsador y pulsador reset


/ * MAPEO DE PUERTO EN ARDUINO
/ * 0 PORTB 0X05
/ * 1 PORTC 0X08
/ * 2 PORTD 0X0B
/ * 3 PINB 0X03
/ * 4 PINC 0X06
/ * 5 PIND 0X09
/ * 6 DDRB 0X04
/ * 7 DDRC 0X07
/ * 8 DDRD 0X0A


$lcdPort 2			
$entrada 4


$almacenb 240
$tmp 241

$num1 242
$num2 243


#setup

/puertos como salida	para el LCD
	mov 252,r0
	out 8	
			
/puerto C como entrada
	mov 0,r0
	out 7
	
	call #lcd_init

/ para ganar espacio se sustituye la rutina 
/	call #lcd_cls		
	mov 1,r0
	call #sendi

#reset	
	mov 48,r0
	mov r0,($num1)	
	mov r0,($num2)	
	jmp #print	
	
#volver:
#uno
	in $entrada
	and 2
	cmp 2
	jz #reset
	
	wait 50
	in $entrada
	and 1
	cmp 1
	jz #uno
	
#dos
	in $entrada
	and 2
	cmp 2
	jz #reset

	wait 50
	in $entrada
	and 1
	cmp 0
	jz #dos	
	

#incre
	mov $num2,r3
	mov (r3),r0
	inc r0
	mov r0,(r3)
	cmp 58
	jnz #print
	mov 48,r0
	mov r0,(r3)
	
	dec r3
	mov (r3),r0
	inc r0
	mov r0,(r3)
	cmp 58
	jnz #print
	mov 48,r0
	mov r0,(r3)
	
	
#print	
/	mov 1,r0
/	call #lcd_at
	mov 129,r0
	call #sendi
	
	mov $num1,r3
	mov (r3),r0
	call #sendchar	
	
	inc r3
	mov (r3),r0
	call #sendchar

	jmp #volver:	



/#lcd_cls
/	mov 1,r0
/	call #sendi
/	ret
	
/R0 lugar en el LCD	
/#lcd_at				
/	or 128
/	call #sendi
/	ret


/Inicializar  valores 3,3,3,2, 40,12,1,6
#lcd_init
	wait 250
#volver	
	call #dato0
	call #enable0
	
	mov 3,r0
	call #pon4bits	
	call #pon4bits	
	call #pon4bits		
	dec r0
	call #pon4bits
	call #dato0
	
	mov  40,r0		/inicializar LCD
	call #sendi
	mov  12,r0
	call #sendi	
	mov  1,r0
	call #sendi
	mov  6,r0
	call #sendi

	ret

/datos de control pasados en r0
#sendi
	call #dato0
	call #sendchar
	wait 3
	call #dato1
	ret

/ char pasado en R0
#sendchar
	push r0
	mov r0,($tmp)
	rr 4
	call #pon4bits
	mov ($tmp),r0
	call #pon4bits
	pop r0
	ret

#enable
	call #enable0
	wait 3
	call #enable1
	wait 3
	call #enable0
	wait 3
	ret


/parametro pasado en R0
#pon4bits
	push r1
	push r0
	and 15
	rl 2
	mov r0,r1		
	mov ($almacenb),r0
	and 195	
	or r1,r0
	mov r0,($almacenb)	
	out $lcdPort
	call #enable
	pop r0
	pop r1
	ret
	
	
#dato1
	push r0
	mov ($almacenb),r0
	or 128
	mov r0,($almacenb)
	out $lcdPort
	pop r0
	ret
	
#dato0	
	push r0
	mov ($almacenb),r0
	and 127
	mov r0,($almacenb)
	out $lcdPort
	pop r0
	ret

#enable1
	push r0
	mov ($almacenb),r0
	or 64
	mov r0,($almacenb)
	out $lcdPort
	pop r0
	ret
	
#enable0
	push r0
	mov ($almacenb),r0
	and 191
	mov r0,($almacenb)
	out $lcdPort
	pop r0
	ret
	
#fin
	
	stop
	end
	
