#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <unistd.h>



#define ANSI1_1 "\033[<1>;<1>H"


#define DISAMBLE  0
#define DEBUG1  0


#define ONZ xRS|=64
#define OFFZ xRS&=191

#define ONC xRS|=1
#define OFFC xRS&=254

#define MAXPORT 10


unsigned char xPC=0,xSP=255,xRS=0,xRI,xRE,xRSI;
unsigned char REG[4];
unsigned char memoria[256]={0};
unsigned char puertos[MAXPORT];
unsigned char puertosx[MAXPORT];
char testPort;

unsigned char mapeo[MAXPORT]={0,1,2,3,4,5,6,7,8,9};



void rPrint(void);
void rnPrint(void);
void r2Print(int r2);
void printBIN(unsigned char num, char *pun);
void portPrint(int a,int b);

int exeOperacion(void);

unsigned char exeIN(unsigned char puerto);
void exeOUT(unsigned char puerto,unsigned char b);


void sleepcp(int milliseconds)
{
        usleep(milliseconds * 1000);
}




unsigned char op,op2;
char nemoError[]="No implementada\n";

int tmpC;

FILE *pf;

int timeWait;
int tipePrint;

int main(int arg,char *argv[])
{
 int z;
 
 //printf("Argumentos %d   %s\n",arg,argv[1]);
 if(arg<2)
    {
        printf("ERROR Debes incluir fichero.bin\n");
        printf("Formato  core8 fichero.bin \n");
        printf("\t-t Tiempo entre operaciones\n");
        printf("\t-p1 Imprimir borrando pantalla\n");
        printf("\t-p2 Imprimir solo puertos\n");
        return(-1);
    }
 pf=fopen(argv[1] ,"rb");
 if(pf==NULL){ printf("ERROR abriendo fichero  \n"); return(-1);    }
    fread(memoria,255,1,pf);
 fclose(pf);
 for(z=1;z<arg;z++)
 {
  if( !strcmp(argv[z],"-t"))   { timeWait=atoi(argv[z+1]);    printf("time=%03d\n",timeWait );     z++;    }
  if( !strcmp(argv[z],"-p1"))  { tipePrint=1;}
  if( !strcmp(argv[z],"-p2"))  { tipePrint=2;}

 }

//return(0);
    printf("Hello world! CORE S8-v3\n");
    REG[0]=0;    REG[1]=0;    REG[2]=0;    REG[3]=0;

    rnPrint(); //Imprime nombre registros
    rPrint();  //Imprime valor registros
    printf("*********************************************************\n\n");
    while(1)
    {
        if(-1==exeOperacion()) { printf("ERROR ejecucion"); break; }

        if(op == 170){ printf("\n----STOP----\n"); break; }
        if(tipePrint==0)
        {
            rnPrint();
            rPrint();
            portPrint(0,3);
            printf("================================\n");
        }


        if(tipePrint==1)
        {
            system("clear");
            rnPrint();
            rPrint();
            portPrint(0,3);
            printf("================================\n");
            printf("CTR+c -.Salir\n");	
        }

        if(tipePrint==2 )
        {
            if(testPort==1)
                {                
				system("clear");
				printf(ANSI1_1 "\n");
				rnPrint();
				rPrint();
				printf("\n=== PORT ===\n");   
				portPrint(0,3);
				printf("================================\n");
				printf("CTR+c .Salir\n");	
                testPort=0; 
                }
        }
        
        if(timeWait>0) sleepcp(timeWait);

    }

 //   for(z=250;z<256;z++)   printf("(%03i)=%03i  ",z,memoria[z]);

    return 0;
}





unsigned char exeIN(unsigned char puerto)
{
    return(puertos[puerto]);
}

void exeOUT(unsigned char puerto,unsigned char b)
{
    //printf("Puerto(%d)  %d\n",puerto,b);
    puertos[puerto]=b;
    testPort=1;
}

//===============DEBUG============================0

void rPrint(void)
{
  printf("%03i  %03i  %03i  %03i  %03i  %03i   ",REG[0],REG[1],REG[2],REG[3],xPC,xSP);
  printf("S=%i  Z=%i  C=%i  RSI=%i\n",xRS>>7,(xRS>>6)&1,xRS&1,xRSI);
}

void rnPrint(void)
{
  printf("\nR0   R1   R2   R3   PC   SP  \n");
}


void printBIN(unsigned char num, char *pun)
{
 int z;
     for(z=0;z<8;z++)
    {
        if((num&128)==128)
            pun[z]='1';
          else
            pun[z]='0';
        num<<=1;
    }
    pun[z]=0;
}


void portPrint(int a,int b)
{
 int z;
 char buffer [10];

    for(z=a;z<b;z++)
        {
         if(z>=MAXPORT) break;
         printBIN(puertos[z],buffer);
         printf("PORT%02u  %03u  %s<\n",z,puertos[z],buffer);
        }

}

//==============================================================

int exeOperacion(void)
{
        op=memoria[xPC];
        if(op==170) return(160);
        #if DISAMBLE
           printf("OP=%03i\tPC=%03i\t ",op,xPC);
        #endif // DISAMBLE
        xPC++;

        if(op<192)
        {
            switch(op)
                {
                    case 0:

                        #if DISAMBLE
                            printf("MOV R0,R0");
                        #endif
                        REG[0]=REG[0];
                    break;
                    case 1:
                        #if DISAMBLE
                            printf("MOV R0,R1");
                        #endif
                         REG[1]=REG[0];
                    break;
                    case 2:
                        #if DISAMBLE
                            printf("MOV R0,R2");
                        #endif
                         REG[2]=REG[0];
                    break;
                    case 3:
                        #if DISAMBLE
                            printf("MOV R0,R3");
                        #endif
                         REG[3]=REG[0];
                    break;
                    case 4:
                        #if DISAMBLE
                            printf("MOV R1,R0");
                        #endif
                         REG[0]=REG[1];
                    break;
                    case 5:
                        #if DISAMBLE
                            printf("MOV R1,R1");
                        #endif
                         REG[1]=REG[1];
                    break;
                    case 6:
                        #if DISAMBLE
                            printf("MOV R1,R2");
                        #endif
                         REG[2]=REG[1];
                    break;
                    case 7:
                        #if DISAMBLE
                            printf("MOV R1,R3");
                        #endif
                         REG[3]=REG[1];
                    break;
                    case 8:
                        #if DISAMBLE
                            printf("MOV R2,R0");
                        #endif
                         REG[0]=REG[2];
                    break;
                    case 9:
                        #if DISAMBLE
                            printf("MOV R2,R1");
                        #endif
                         REG[1]=REG[2];
                    break;
                    case 10:
                        #if DISAMBLE
                            printf("MOV R2,R2");
                        #endif
                         REG[2]=REG[2];
                    break;
                    case 11:
                        #if DISAMBLE
                            printf("MOV R2,R3");
                        #endif
                         REG[3]=REG[2];
                    break;
                    case 12:
                        #if DISAMBLE
                            printf("MOV R3,R0");
                        #endif
                         REG[0]=REG[3];
                    break;
                    case 13:
                        #if DISAMBLE
                            printf("MOV R3,R1");
                        #endif
                         REG[1]=REG[3];
                    break;
                    case 14:
                        #if DISAMBLE
                            printf("MOV R3,R2");
                        #endif
                         REG[2]=REG[3];
                    break;
                    case 15:
                        #if DISAMBLE
                            printf("MOV R3,R3");
                        #endif
                         REG[3]=REG[3];
                    break;
                    case 16:
                        #if DISAMBLE
                            printf("MOV (R0),R0");
                        #endif
                         REG[0]=memoria[REG[0]];
                    break;
                    case 17:
                        #if DISAMBLE
                            printf("MOV (R0),R1");
                        #endif
                        REG[1]=memoria[REG[0]];
                    break;
                    case 18:
                        #if DISAMBLE
                            printf("MOV (R0),R2");
                        #endif
                        REG[2]=memoria[REG[0]];
                    break;
                    case 19:
                        #if DISAMBLE
                            printf("MOV (R0),R3");
                        #endif
                        REG[3]=memoria[REG[0]];
                    break;
                    case 20:
                        #if DISAMBLE
                            printf("MOV (R1),R0");
                        #endif
                        REG[0]=memoria[REG[1]];
                    break;
                    case 21:
                        #if DISAMBLE
                            printf("MOV (R1),R1");
                        #endif
                        REG[1]=memoria[REG[1]];
                    break;
                    case 22:
                        #if DISAMBLE
                            printf("MOV (R1),R2");
                        #endif
                        REG[2]=memoria[REG[1]];
                    break;
                    case 23:
                        #if DISAMBLE
                            printf("MOV (R1),R3");
                        #endif
                        REG[3]=memoria[REG[1]];
                    break;
                    case 24:
                        #if DISAMBLE
                            printf("MOV (R2),R0");
                        #endif
                        REG[0]=memoria[REG[2]];
                    break;
                    case 25:
                        #if DISAMBLE
                            printf("MOV (R2),R1");
                        #endif
                        REG[1]=memoria[REG[2]];
                    break;
                    case 26:
                        #if DISAMBLE
                            printf("MOV (R2),R2");
                        #endif
                        REG[2]=memoria[REG[2]];
                    break;
                    case 27:
                        #if DISAMBLE
                            printf("MOV (R2),R3");
                        #endif
                        REG[3]=memoria[REG[2]];
                    break;
                    case 28:
                        #if DISAMBLE
                            printf("MOV (R3),R0");
                        #endif
                        REG[0]=memoria[REG[3]];
                    break;
                    case 29:
                        #if DISAMBLE
                            printf("MOV (R3),R1");
                        #endif
                        REG[1]=memoria[REG[3]];
                    break;
                    case 30:
                        #if DISAMBLE
                            printf("MOV (R3),R2");
                        #endif
                        REG[2]=memoria[REG[3]];
                    break;
                    case 31:
                        #if DISAMBLE
                            printf("MOV (R3),R3");
                        #endif
                        REG[3]=memoria[REG[3]];
                    break;
                    case 32:
                        #if DISAMBLE
                            printf("MOV R0,(R0)");
                        #endif
                        memoria[REG[0]]=REG[0];
                    break;
                    case 33:
                        #if DISAMBLE
                            printf("MOV R0,(R1)");
                        #endif
                        memoria[REG[1]]=REG[0];
                    break;
                    case 34:
                        #if DISAMBLE
                            printf("MOV R0,(R3)");
                        #endif
                        memoria[REG[3]]=REG[0];
                    break;
                    case 35:
                        #if DISAMBLE
                            printf("MOV R0,(R3)");
                        #endif
                        memoria[REG[3]]=REG[0];
                    break;
                    case 36:
                        #if DISAMBLE
                            printf("MOV R1,(R0)");
                        #endif
                        memoria[REG[0]]=REG[1];
                    break;
                    case 37:
                        #if DISAMBLE
                            printf("MOV R1,(R1)");
                        #endif
                        memoria[REG[1]]=REG[1];
                    break;
                    case 38:
                        #if DISAMBLE
                            printf("MOV R1,(R2)");
                        #endif
                        memoria[REG[2]]=REG[1];
                    break;
                    case 39:
                        #if DISAMBLE
                            printf("MOV R1,(R3)");
                        #endif
                        memoria[REG[3]]=REG[1];
                    break;
                    case 40:
                        #if DISAMBLE
                            printf("MOV R2,(R0)");
                        #endif
                        memoria[REG[0]]=REG[2];
                    break;
                    case 41:
                        #if DISAMBLE
                            printf("MOV R2,(R1)");
                        #endif
                        memoria[REG[1]]=REG[2];
                    break;
                    case 42:
                        #if DISAMBLE
                            printf("MOV R2,(R2)");
                        #endif
                        memoria[REG[2]]=REG[2];
                    break;
                    case 43:
                        #if DISAMBLE
                            printf("MOV R2,(R3)");
                        #endif
                        memoria[REG[3]]=REG[2];
                    break;
                    case 44:
                        #if DISAMBLE
                            printf("MOV R3,(R0)");
                        #endif
                        memoria[REG[0]]=REG[3];
                    break;
                    case 45:
                        #if DISAMBLE
                            printf("MOV R3,(R1)");
                        #endif
                        memoria[REG[1]]=REG[3];
                    break;
                    case 46:
                        #if DISAMBLE
                            printf("MOV R3,(R2)");
                        #endif
                    break;
                    memoria[REG[2]]=REG[3];
                    case 47:
                        #if DISAMBLE
                            printf("MOV R3,(R3)");
                        #endif
                        memoria[REG[3]]=REG[3];
                    break;
                    case 48:
                        #if DISAMBLE
                            printf("CMP R0,R0");
                        #endif
                        if(REG[0]==REG[0]) ONZ ; else OFFZ ;    //Z
                        if(REG[0]>REG[0]) xRS|=128; else xRS&=127;    //S
                    break;
                    case 49:
                        #if DISAMBLE
                            printf("CMP R0,R1");
                        #endif
                        if(REG[0]==REG[1]) ONZ ; else OFFZ ;    //Z
                        if(REG[0]>REG[1]) xRS|=128; else xRS&=127;    //S
                    break;
                    case 50:
                        #if DISAMBLE
                            printf("CMP R0,R2");
                        #endif
                        if(REG[0]==REG[2]) ONZ ; else OFFZ ;    //Z
                        if(REG[0]>REG[2]) xRS|=128; else xRS&=127;    //S
                    break;
                    case 51:
                        #if DISAMBLE
                            printf("CMP R0,R3");
                        #endif
                        if(REG[0]==REG[3]) ONZ ; else OFFZ ;    //Z
                        if(REG[0]>REG[3]) xRS|=128; else xRS&=127;    //S
                    break;
                    case 52:
                        #if DISAMBLE
                            printf("CMP R1,R0");
                        #endif
                        if(REG[1]==REG[0]) ONZ ; else OFFZ ;    //Z
                        if(REG[1]>REG[0]) xRS|=128; else xRS&=127;    //S
                    break;
                    case 53:
                        #if DISAMBLE
                            printf("CMP R1,R1");
                        #endif
                        if(REG[1]==REG[1]) ONZ ; else OFFZ ;    //Z
                        if(REG[1]>REG[1]) xRS|=128; else xRS&=127;    //S
                    break;
                    case 54:
                        #if DISAMBLE
                            printf("CMP R1,R2");
                        #endif
                        if(REG[1]==REG[2]) ONZ ; else OFFZ ;    //Z
                        if(REG[1]>REG[2]) xRS|=128; else xRS&=127;    //S
                    break;
                    case 55:
                        #if DISAMBLE
                            printf("CMP R1,R3");
                        #endif
                        if(REG[1]==REG[3]) ONZ ; else OFFZ ;    //Z
                        if(REG[1]>REG[3]) xRS|=128; else xRS&=127;    //S
                    break;
                    case 56:
                        #if DISAMBLE
                            printf("CMP R2,R0");
                        #endif
                        if(REG[2]==REG[0]) ONZ ; else OFFZ ;    //Z
                        if(REG[2]>REG[0]) xRS|=128; else xRS&=127;    //S
                    break;
                    case 57:
                        #if DISAMBLE
                            printf("CMP R2,R1");
                        #endif
                        if(REG[2]==REG[1]) ONZ ; else OFFZ ;    //Z
                        if(REG[2]>REG[1]) xRS|=128; else xRS&=127;    //S
                    break;
                    case 58:
                        #if DISAMBLE
                            printf("CMP R2,R2");
                        #endif
                        if(REG[2]==REG[2]) ONZ ; else OFFZ ;    //Z
                        if(REG[2]>REG[2]) xRS|=128; else xRS&=127;    //S
                    break;
                    case 59:
                        #if DISAMBLE
                            printf("CMP R2,R3");
                        #endif
                        if(REG[2]==REG[3]) ONZ ; else OFFZ ;    //Z
                        if(REG[2]>REG[3]) xRS|=128; else xRS&=127;    //S
                    break;
                    case 60:
                        #if DISAMBLE
                            printf("CMP R3,R0");
                        #endif
                        if(REG[3]==REG[0]) ONZ ; else OFFZ ;    //Z
                        if(REG[3]>REG[0]) xRS|=128; else xRS&=127;    //S
                    break;
                    case 61:
                        #if DISAMBLE
                            printf("CMP R3,R1");
                        #endif
                        if(REG[3]==REG[1]) ONZ ; else OFFZ ;    //Z
                        if(REG[3]>REG[1]) xRS|=128; else xRS&=127;    //S
                    break;
                    case 62:
                        #if DISAMBLE
                            printf("CMP R3,R2");
                        #endif
                        if(REG[3]==REG[2]) ONZ ; else OFFZ ;    //Z
                        if(REG[3]>REG[2]) xRS|=128; else xRS&=127;    //S
                    break;
                    case 63:
                        #if DISAMBLE
                            printf("CMP R3,R3");
                        #endif
                        if(REG[3]==REG[3]) ONZ ; else OFFZ ;    //Z
                        if(REG[3]>REG[3]) xRS|=128; else xRS&=127;    //S
                    break;
                    case 64:
                        #if DISAMBLE
                            printf("ADD R0,R0");
                        #endif
                        tmpC=REG[0]+REG[0];
                        REG[0]=tmpC;
                        if(tmpC>255) xRS|=1; else xRS&=1;
                        if(tmpC==0 ) ONZ ; else OFFZ ;
                    break;
                    case 65:
                        #if DISAMBLE
                            printf("ADD R0,R1");
                        #endif
                        tmpC=REG[1]+REG[0];
                        REG[0]=tmpC;
                        if(tmpC>255) xRS|=1; else xRS&=1;
                        if(tmpC==0 ) ONZ ; else OFFZ ;
                    break;
                    case 66:
                        #if DISAMBLE
                            printf("ADD R0,R2");
                        #endif
                        tmpC=REG[0]+REG[2];
                        REG[2]=tmpC;
                        if(tmpC>255) xRS|=1; else xRS&=1;
                        if(tmpC==0 ) ONZ ; else OFFZ ;
                    break;
                    case 67:
                        #if DISAMBLE
                            printf("ADD R0,R3");
                        #endif
                        tmpC=REG[0]+REG[3];
                        REG[3]=tmpC;
                        if(tmpC>255) xRS|=1; else xRS&=1;
                        if(tmpC==0 ) ONZ ; else OFFZ ;
                    break;
                    case 68:
                        #if DISAMBLE
                            printf("ADD R1,R0");
                        #endif
                        tmpC=REG[1]+REG[0];
                        REG[0]=tmpC;
                        if(tmpC>255) xRS|=1; else xRS&=1;
                        if(tmpC==0 ) ONZ ; else OFFZ ;
                    break;
                    case 69:
                        #if DISAMBLE
                            printf("ADD R1,R1");
                        #endif
                        tmpC=REG[1]+REG[1];
                        REG[1]=tmpC;
                        if(tmpC>255) xRS|=1; else xRS&=1;
                        if(tmpC==0 ) ONZ ; else OFFZ ;
                    break;
                    case 70:
                        #if DISAMBLE
                            printf("ADD R1,R2");
                        #endif
                        tmpC=REG[1]+REG[2];
                        REG[2]=tmpC;
                        if(tmpC>255) xRS|=1; else xRS&=1;
                        if(tmpC==0 ) ONZ ; else OFFZ ;
                    break;
                    case 71:
                        #if DISAMBLE
                            printf("ADD R1,R3");
                        #endif
                        tmpC=REG[1]+REG[3];
                        REG[3]=tmpC;
                        if(tmpC>255) xRS|=1; else xRS&=1;
                        if(tmpC==0 ) ONZ ; else OFFZ ;
                    break;
                    case 72:
                        #if DISAMBLE
                            printf("ADD R2,R0");
                        #endif
                        tmpC=REG[2]+REG[0];
                        REG[0]=tmpC;
                        if(tmpC>255) xRS|=1; else xRS&=1;
                        if(tmpC==0 ) ONZ ; else OFFZ ;
                    break;
                    case 73:
                        #if DISAMBLE
                            printf("ADD R2,R1");
                        #endif
                        tmpC=REG[2]+REG[1];
                        REG[1]=tmpC;
                        if(tmpC>255) xRS|=1; else xRS&=1;
                        if(tmpC==0 ) ONZ ; else OFFZ ;
                    break;
                    case 74:
                        #if DISAMBLE
                            printf("ADD R2,R2");
                        #endif
                        tmpC=REG[2]+REG[2];
                        REG[2]=tmpC;
                        if(tmpC>255) xRS|=1; else xRS&=1;
                        if(tmpC==0 ) ONZ ; else OFFZ ;
                    break;
                    case 75:
                        #if DISAMBLE
                            printf("ADD R2,R3");
                        #endif
                        tmpC=REG[2]+REG[3];
                        REG[3]=tmpC;
                        if(tmpC>255) xRS|=1; else xRS&=1;
                        if(tmpC==0 ) ONZ ; else OFFZ ;
                    break;
                    case 76:
                        #if DISAMBLE
                            printf("ADD R3,R0");
                        #endif
                        tmpC=REG[3]+REG[0];
                        REG[0]=tmpC;
                        if(tmpC>255) xRS|=1; else xRS&=1;
                        if(tmpC==0 ) ONZ ; else OFFZ ;
                    break;
                    case 77:
                        #if DISAMBLE
                            printf("ADD R3,R1");
                        #endif
                        tmpC=REG[3]+REG[1];
                        REG[1]=tmpC;
                        if(tmpC>255) xRS|=1; else xRS&=1;
                        if(tmpC==0 ) ONZ ; else OFFZ ;
                    break;
                    case 78:
                        #if DISAMBLE
                            printf("ADD R3,R2");
                        #endif
                        tmpC=REG[3]+REG[2];
                        REG[2]=tmpC;
                        if(tmpC>255) xRS|=1; else xRS&=1;
                        if(tmpC==0 ) ONZ ; else OFFZ ;
                    break;
                    case 79:
                        #if DISAMBLE
                            printf("ADD R3,R3");
                        #endif
                        tmpC=REG[3]+REG[3];
                        REG[3]=tmpC;
                        if(tmpC>255) xRS|=1; else xRS&=1;
                        if(tmpC==0 ) ONZ ; else OFFZ ;
                    break;

                    case 96:
                        #if DISAMBLE
                            printf("SUB R0,R0");
                        #endif
                        tmpC=REG[0]-REG[0];
                        REG[0]=tmpC;
                        if(tmpC==0 ) ONZ ; else OFFZ ;
                        if(tmpC<0) ONC; else OFFC;       //?????????
                    break;
                    case 97:
                        #if DISAMBLE
                            printf("SUB R0,R1");
                        #endif
                        tmpC=REG[0]-REG[1];
                        REG[1]=tmpC;
                        if(tmpC==0 ) ONZ ; else OFFZ ;
                        if(tmpC<0)   ONC ; else OFFC ;
                    break;
                    case 98:
                        #if DISAMBLE
                            printf("SUB R0,R2");
                        #endif
                        tmpC=REG[0]-REG[2];
                        REG[2]=tmpC;
                        if(tmpC==0 ) ONZ ; else OFFZ ;
                        if(tmpC<0)   ONC ; else OFFC ;
                    break;
                    case 99:
                        #if DISAMBLE
                            printf("SUB R0,R3");
                        #endif
                        tmpC=REG[0]-REG[3];
                        REG[3]=tmpC;
                        if(tmpC==0 ) ONZ ; else OFFZ ;
                        if(tmpC<0)   ONC ; else OFFC ;
                    break;
                    case 100:
                        #if DISAMBLE
                            printf("SUB R1,R0");
                        #endif
                        tmpC=REG[1]-REG[0];
                        REG[0]=tmpC;
                        if(tmpC==0 ) ONZ ; else OFFZ ;
                        if(tmpC<0)   ONC ; else OFFC ;
                    break;
                    case 101:
                        #if DISAMBLE
                            printf("SUB R1,R1");
                        #endif
                        tmpC=REG[1]-REG[1];
                        REG[1]=tmpC;
                        if(tmpC==0 ) ONZ ; else OFFZ ;
                        if(tmpC<0)   ONC ; else OFFC ;
                    break;
                    case 102:
                        #if DISAMBLE
                            printf("SUB R1,R2");
                        #endif
                        tmpC=REG[1]-REG[2];
                        REG[2]=tmpC;
                        if(tmpC==0 ) ONZ ; else OFFZ ;
                        if(tmpC<0)   ONC ; else OFFC ;
                    break;
                    case 103:
                        #if DISAMBLE
                            printf("SUB R1,R3");
                        #endif
                        tmpC=REG[1]-REG[3];
                        REG[3]=tmpC;
                        if(tmpC==0 ) ONZ ; else OFFZ ;
                        if(tmpC<0)   ONC ; else OFFC ;
                    break;
                    case 104:
                        #if DISAMBLE
                            printf("SUB R2,R0");
                        #endif
                        tmpC=REG[2]-REG[0];
                        REG[0]=tmpC;
                        if(tmpC==0 ) ONZ ; else OFFZ ;
                        if(tmpC<0)   ONC ; else OFFC ;
                    break;
                    case 105:
                        #if DISAMBLE
                            printf("SUB R2,R1");
                        #endif
                        tmpC=REG[2]-REG[1];
                        REG[1]=tmpC;
                        if(tmpC==0 ) ONZ ; else OFFZ ;
                        if(tmpC<0)   ONC ; else OFFC ;
                    break;
                    case 106:
                        #if DISAMBLE
                            printf("SUB R2,R2");
                        #endif
                        tmpC=REG[2]-REG[2];
                        REG[2]=tmpC;
                        if(tmpC==0 ) ONZ ; else OFFZ ;
                        if(tmpC<0)   ONC ; else OFFC ;
                    break;
                    case 107:
                        #if DISAMBLE
                            printf("SUB R2,R3");
                        #endif
                        tmpC=REG[2]-REG[3];
                        REG[3]=tmpC;
                        if(tmpC==0 ) ONZ ; else OFFZ ;
                        if(tmpC<0)   ONC ; else OFFC ;
                    break;
                    case 108:
                        #if DISAMBLE
                            printf("SUB R3,R0");
                        #endif
                        tmpC=REG[3]-REG[0];
                        REG[0]=tmpC;
                        if(tmpC==0 ) ONZ ; else OFFZ ;
                        if(tmpC<0)   ONC ; else OFFC ;
                    break;
                    case 109:
                        #if DISAMBLE
                            printf("SUB R3,R1");
                        #endif
                        tmpC=REG[3]-REG[1];
                        REG[1]=tmpC;
                        if(tmpC==0 ) ONZ ; else OFFZ ;
                        if(tmpC<0)   ONC ; else OFFC ;
                    break;
                    case 110:
                        #if DISAMBLE
                            printf("SUB R3,R2");
                        #endif
                        tmpC=REG[3]-REG[2];
                        REG[2]=tmpC;
                        if(tmpC==0 ) ONZ ; else OFFZ ;
                        if(tmpC<0)   ONC ; else OFFC ;
                    break;
                    case 111:
                        #if DISAMBLE
                            printf("SUB R3,R3");
                        #endif
                        tmpC=REG[3]-REG[3];
                        REG[3]=tmpC;
                        if(tmpC==0 ) ONZ ; else OFFZ ;
                        if(tmpC<0)   ONC ; else OFFC ;
                    break;
                    case 128:
                        #if DISAMBLE
                            printf("PUSH R0");
                        #endif
                        memoria[xSP]=REG[0];    xSP--;
                    break;
                    case 129:
                        #if DISAMBLE
                            printf("PUSH R1");
                        #endif
                        memoria[xSP]=REG[1];    xSP--;
                    break;
                    case 130:
                        #if DISAMBLE
                            printf("PUSH R2");
                        #endif
                        memoria[xSP]=REG[2];    xSP--;
                    break;
                    case 131:
                        #if DISAMBLE
                            printf("PUSH R3");
                        #endif
                        memoria[xSP]=REG[3];    xSP--;
                    break;
                    case 132:
                        #if DISAMBLE
                            printf("POP R0");
                        #endif
                        xSP++;        REG[0]=memoria[xSP];
                    break;
                    case 133:
                        #if DISAMBLE
                            printf("POP R1");
                        #endif
                        xSP++;        REG[1]=memoria[xSP];
                    break;
                    case 134:
                        #if DISAMBLE
                            printf("POP R2");
                        #endif
                        xSP++;        REG[2]=memoria[xSP];
                    break;
                    case 135:
                        #if DISAMBLE
                            printf("POP R3");
                        #endif
                        xSP++;        REG[3]=memoria[xSP];
                    break;
                    case 136:
                        #if DISAMBLE
                            printf("INV R0");
                        #endif
                        REG[0] = ~REG[0];  if(REG[0]==0) ONZ ; else OFFZ ;
                    break;
                    case 137:
                        #if DISAMBLE
                            printf("INV R1");
                        #endif
                        REG[1] = ~REG[1];  if(REG[1]==0) ONZ ; else OFFZ ;
                    break;
                    case 138:
                        #if DISAMBLE
                            printf("INV R2");
                        #endif
                        REG[2] = ~REG[2];  if(REG[2]==0) ONZ ; else OFFZ ;
                    break;
                    case 139:
                        #if DISAMBLE
                            printf("INV R3");
                        #endif
                        REG[3] = ~REG[3];  if(REG[3]==0) ONZ ; else OFFZ ;
                    break;
                    case 140:
                        #if DISAMBLE
                            printf("CLEAR R0");
                        #endif
                        xRS=0; REG[0]=0;
                    break;
                    case 141:
                        #if DISAMBLE
                            printf("CLEAR R1");
                        #endif
                        xRS=0; REG[1]=0;
                    break;
                    case 142:
                        #if DISAMBLE
                            printf("CLEAR R2");
                        #endif
                        xRS=0; REG[2]=0;
                    break;
                    case 143:
                        #if DISAMBLE
                            printf("CLEAR R3");
                        #endif
                        xRS=0; REG[3]=0;
                    break;


                    case 148:
                        #if DISAMBLE
                            printf("MOV (R1+),R0");
                        #endif
                        REG[0]=memoria[REG[1]];   REG[2]++;
                    break;
                    case 149:
                        #if DISAMBLE
                            printf("MOV R0,(R2+)");
                        #endif
                        memoria[REG[2]]=REG[0];   REG[2]++;
                    break;
                    case 150:
                        #if DISAMBLE
                            printf("MOV(R1+),(R2+)  R0++");
                        #endif
                        memoria[REG[2]]=memoria[REG[1]];   REG[0]++; REG[1]++; REG[2]++;
                    break;
                    case 156:
                        #if DISAMBLE
                            printf("AND R1,R0");
                        #endif
                        REG[0] &= REG[1];        if(REG[0]==0) ONZ ; else OFFZ ;
                    break;
                    case 157:
                        #if DISAMBLE
                            printf("OR R1,R0");
                        #endif
                        REG[0] |= REG[1];        if(REG[0]==0) ONZ ; else OFFZ ;
                    break;
                    case 158:
                        #if DISAMBLE
                            printf("XOR R1,R0");
                        #endif
                        REG[0] ^= REG[1];        if(REG[0]==0) ONZ ; else OFFZ ;
                    break;


                    case 160:
                        #if DISAMBLE
                            printf("MOV R0->PC");
                        #endif
                        xPC=REG[0];
                    break;
                    case 161:
                        #if DISAMBLE
                            printf("MOV R0->SP");
                        #endif
                        xSP=REG[0];
                    break;
                    case 162:
                        #if DISAMBLE
                            printf("MOV R0->RI");
                        #endif
                        xRI=REG[0];
                    break;
                    case 163:
                        #if DISAMBLE
                            printf("MOV R0->RE ");
                        #endif
                        xRE=REG[0];
                    break;
                    case 164:
                        #if DISAMBLE
                            printf("ENABLE I ");
                        #endif
                        xRSI=xRSI | 1;
                    break;
                    case 165:
                        #if DISAMBLE
                           printf("DISABLE I ");
                        #endif
                        xRSI=xRSI & 254;
                    break;
                    case 166:
                        #if DISAMBLE
                            if(DISAMBLE) printf("ENABLE E ");
                        #endif
                        xRSI=xRSI | 2;
                    break;
                    case 167:
                        #if DISAMBLE
                            printf("DISABLE E ");
                        #endif
                        xRSI=xRSI & 253;
                    break;
                    case 168:
                        #if DISAMBLE
                            printf("RET ");
                        #endif
                        xSP++;   xPC=memoria[xSP];
                    break;
                    case 169:
                        #if DISAMBLE
                            if(DISAMBLE) printf("NOP ");
                        #endif
                        sleepcp(1);
                    break;


                    case 174:
                        #if DISAMBLE
                            printf("IN (R1)->R0 ");
                        #endif
                        REG[0]=exeIN(REG[1]);
                    break;
                    case 175:
                        #if DISAMBLE
                            printf("OUT R0->(R1) ");
                        #endif
                        exeOUT(REG[1],REG[0]);
                    break;


                    case 176:
                        #if DISAMBLE
                            printf("INC R0");
                        #endif
                        tmpC=REG[0];  ++REG[0];   xRS=0;
                        if(REG[0]==0) ONZ ; else OFFZ ;    //Z
                        if(tmpC>255) ONC ; else OFFC ;
                    break;
                    case 177:
                        #if DISAMBLE
                            printf("INC R1");
                        #endif
                        tmpC=REG[1];  ++REG[1];   xRS=0;
                        if(REG[1]==0) ONZ ; else OFFZ ;    //Z
                        if(tmpC>255) ONC ; else OFFC ;
                    break;
                    case 178:
                        #if DISAMBLE
                            printf("INC R2");
                        #endif
                        tmpC=REG[2];  ++REG[2];   xRS=0;
                        if(REG[2]==0) ONZ ; else OFFZ ;    //Z
                        if(tmpC>255) ONC ; else OFFC ;
                    break;
                    case 179:
                        #if DISAMBLE
                            printf("INC R3");
                        #endif
                        tmpC=REG[3];  ++REG[3];   xRS=0;
                        if(REG[3]==0) ONZ ; else OFFZ ;    //Z
                        if(tmpC>255) ONC ; else OFFC ;
                    break;
                    case 180:
                        #if DISAMBLE
                            printf("DEC R0");
                        #endif
                        tmpC=REG[0]-1;  --REG[0];   xRS=0;
                        if(REG[0]==0) ONZ ; else OFFZ ;     //Z
                        if(tmpC<0) ONC ; else OFFC ;
                    break;
                    case 181:
                        #if DISAMBLE
                            printf("DEC R1");
                        #endif
                        tmpC=REG[1]-1;  --REG[1];   xRS=0;
                        if(REG[1]==0) ONZ ; else OFFZ ;     //Z
                        if(tmpC<0) ONC ; else OFFC ;
                    break;
                    case 182:
                        #if DISAMBLE
                            printf("DEC R2");
                        #endif
                        tmpC=REG[2]-1;  --REG[2];   xRS=0;
                        if(REG[2]==0) ONZ ; else OFFZ ;     //Z
                        if(tmpC<0) ONC ; else OFFC ;
                    break;
                    case 183:
                        #if DISAMBLE
                            printf("DEC R3");
                        #endif
                        tmpC=REG[3]-1;  --REG[3];   xRS=0;
                        if(REG[3]==0) ONZ ; else OFFZ ;     //Z
                        if(tmpC<0) ONC ; else OFFC ;
                    break;



                    default:
                        printf("%s",nemoError);
                        return(-1);
                    break;

                }
         }
        else
         {
            op2=memoria[xPC];
            xPC++;
            switch(op)
                {

                    case 192:
                        #if DISAMBLE
                            printf("CALL %u",op2);
                        #endif
                        memoria[xSP]=xPC;    xSP--;  xPC=op2;
                    break;
                    case 193:
                        #if DISAMBLE
                            printf("JMP %u",op2);
                        #endif
                        xPC=op2;
                    break;
                    case 194:
                        #if DISAMBLE
                            printf("JZ %u",op2);
                        #endif
                        if ( (xRS & 64)==64 ) xPC=op2;
                    break;
                    case 195:
                        #if DISAMBLE
                            printf("JNZ %u",op2);
                        #endif
                        if ( (xRS & 64)==0  ) xPC=op2;
                    break;
                    case 196:
                        #if DISAMBLE
                            printf("JC %u",op2);
                        #endif
                        if ( (xRS & 1)==1 ) xPC=op2;
                    break;
                    case 197:
                        #if DISAMBLE
                            printf("JNC %u",op2);
                        #endif
                        if ( (xRS & 1)==0  ) xPC=op2;
                    break;
                    case 198:
                        #if DISAMBLE
                            printf("JS %u",op2);
                        #endif
                        if ( (xRS & 128)==128 ) xPC=op2;
                    break;
                    case 199:
                        #if DISAMBLE
                            printf("JNS %u",op2);
                        #endif
                        if ( (xRS & 128)==0  ) xPC=op2;
                    break;
                    case 200:
                        #if DISAMBLE
                            printf("RL %u,R0",op2);
                        #endif
                        REG[0] <<=op2;
                        if(REG[0]==0) ONZ ; else OFFZ ;
                    break;
                    case 201:
                        #if DISAMBLE
                            printf("RR %u,R0",op2);
                        #endif
                        REG[0] >>=op2;
                        if(REG[0]==0) ONZ ; else OFFZ ;
                    break;
                    case 202:
                        #if DISAMBLE
                            printf("AND %u,R0",op2);
                        #endif
                        REG[0] &=op2;
                        if(REG[0]==0) ONZ ; else OFFZ ;
                    break;
                    case 203:
                        #if DISAMBLE
                            printf("OR %u,R0",op2);
                        #endif
                        REG[0] |=op2;
                        if(REG[0]==0) ONZ ; else OFFZ ;
                    break;
                    case 204:
                        #if DISAMBLE
                            printf("XOR %u,R0",op2);
                        #endif
                        REG[0] ^=op2;
                        if(REG[0]==0) ONZ ; else OFFZ ;
                    break;
                    case 205:
                        #if DISAMBLE
                            printf("IN (%u),R0",op2);
                        #endif
                        REG[0]=exeIN(op2);
                        if(REG[0]==0) ONZ ; else OFFZ ;
                    break;
                    case 206:
                        #if DISAMBLE
                            printf("OUT R0,(%u)",op2);
                        #endif
                        exeOUT(op2,REG[0]);
                    break;
                    case 207:
                        #if DISAMBLE
                            printf("CMP %u",op2);
                        #endif
                        if(REG[0]==op2) ONZ ; else OFFZ ;    //Z
                        if(REG[0]>op2) xRS|=128; else xRS&=127;    //S
                    break;
                    case 208:
                        #if DISAMBLE
                            printf("MOV %u,R0",op2);
                        #endif
                         REG[0]=op2;
                    break;
                    case 209:
                        #if DISAMBLE
                             printf("MOV %u,R1",op2);
                        #endif
                        REG[1]=op2;
                    break;
                    case 210:
                        #if DISAMBLE
                            printf("MOV %u,R2",op2);
                        #endif
                        REG[2]=op2;
                    break;
                    case 211:
                        #if DISAMBLE
                             printf("MOV %u,R3",op2);
                        #endif
                        REG[3]=op2;
                    break;
                    case 212:
                        #if DISAMBLE
                            printf("MOV (%u),R0",op2);
                        #endif
                        REG[0]=memoria[op2];
                    break;
                    case 213:
                        #if DISAMBLE
                             printf("MOV (%u),R1",op2);
                        #endif
                         REG[1]=memoria[op2];
                    break;
                    case 214:
                        #if DISAMBLE
                             printf("MOV (%u),R2",op2);
                        #endif
                         REG[2]=memoria[op2];
                    break;
                    case 215:
                        #if DISAMBLE
                             printf("MOV (%u),R3",op2);
                        #endif
                         REG[3]=memoria[op2];
                    break;
                    case 216:
                        #if DISAMBLE
                             printf("MOV R0,(%u)",op2);
                        #endif
                        memoria[op2]=REG[0];
                    break;
                    case 217:
                        #if DISAMBLE
                            printf("MOV R1,(%u)",op2);
                        #endif
                        memoria[op2]=REG[1];
                    break;
                    case 218:
                        #if DISAMBLE
                            printf("MOV R2,(%u)",op2);
                        #endif
                        memoria[op2]=REG[2];
                    break;
                    case 219:
                        #if DISAMBLE
                            printf("MOV R3,(%u)",op2);
                        #endif
                        memoria[op2]=REG[3];
                    break;
                    case 220:
                        #if DISAMBLE
                            printf("WAIT %u",op2);
                        #endif
                        sleepcp(op2);
                    break;


                    default:
                        printf("%s",nemoError);
                        return(-1);
                    break;

                }
        }
return(0);
}


