#include <stdio.h>
#include <stdlib.h>

#include <string.h>


#define LINEMAX 100
#define VARMAX 50

int quitarFinLinea(void);
int Mayusculas(void);
int quitarSPACE(void);
int changeSrt(char *cadena, char *busqueda, char *cambio);
void changeVar(void);
void changeSaltos(void);

int preprocesador(int modo);
                       

struct VARIABLES { char nombre[12]; int valor; };
struct VARIABLES variables[VARMAX];
int nvariables;


FILE *pf, *pfasm;
char lineaE[LINEMAX];
char lineaEe[LINEMAX*2];

char etiqueta[20]="";
int indice;

//----------------------------------------------
int buscarCode1(void);
int buscarCode2(void);

int getValor(char *nombre);
int getValorSaltos(char *nombre);

void printVariables(void);
void printError(void);

int saveCodigo(int modo);

static char *codigoN[]={ "0", "MOV R0,R0", "1", "MOV R0,R1", "2", "MOV R0,R2","3","MOV R0,R3",
                         "4", "MOV R1,R0", "5", "MOV R1,R1", "6", "MOV R1,R2","7","MOV R1,R3",
                         "8", "MOV R2,R0", "9", "MOV R2,R1", "10", "MOV R2,R2","11","MOV R2,R3",
                         "12", "MOV R3,R0", "13", "MOV R3,R1", "14", "MOV R3,R2","15","MOV R3,R3",
                         "16", "MOV (R0),R0", "17", "MOV (R0),R1", "18", "MOV (R0),R2","19","MOV (R0),R3",
                         "20", "MOV (R1),R0", "21", "MOV (R1),R1", "22", "MOV (R1),R2","23","MOV (R1),R3",
                         "24", "MOV (R2),R0", "25", "MOV (R2),R1", "26", "MOV (R2),R2","27","MOV (R2),R3",
                         "28", "MOV (R3),R0", "29", "MOV (R3),R1", "30", "MOV (R3),R2","31","MOV (R3),R3",
                         "32", "MOV R0,(R0)", "33", "MOV R0,(R1)", "34", "MOV R0,(R2)","35","MOV R0,(R3)",
                         "36", "MOV R1,(R0)", "37", "MOV R1,(R1)", "38", "MOV R1,(R2)","39","MOV R1,(R3)",
                         "40", "MOV R2,(R0)", "41", "MOV R2,(R1)", "42", "MOV R2,(R2)","43","MOV R2,(R3)",
                         "44", "MOV R3,(R0)", "45", "MOV R3,(R1)", "46", "MOV R3,(R2)","47","MOV R3,(R3)",

                         "48", "CMP R0,R0", "49", "CMP R0,R1", "50", "CMP R0,R2","51","CMP R0,R3",
                         "52", "CMP R1,R0", "53", "CMP R1,R1", "54", "CMP R1,R2","55","CMP R1,R3",
                         "56", "CMP R2,R0", "57", "CMP R2,R1", "58", "CMP R2,R2","59","CMP R2,R3",
                         "60", "CMP R3,R0", "61", "CMP R3,R1", "62", "CMP R3,R2","63","CMP R3,R3",

                         "64", "ADD R0,R0", "65", "ADD R0,R1", "66", "ADD R0,R2","67","ADD R0,R3",
                         "68", "ADD R1,R0", "69", "ADD R1,R1", "70", "ADD R1,R2","71","ADD R1,R3",
                         "72", "ADD R2,R0", "73", "ADD R2,R1", "74", "ADD R2,R2","75","ADD R2,R3",
                         "76", "ADD R3,R0", "77", "ADD R3,R1", "78", "ADD R3,R2","79","ADD R3,R3",

                         "96", "SUB R0,R0", "97", "SUB R0,R1", "98", "SUB R0,R2","99","SUB R0,R3",
                         "100", "SUB R1,R0", "101", "SUB R1,R1", "102", "SUB R1,R2","103","SUB R1,R3",
                         "104", "SUB R2,R0", "105", "SUB R2,R1", "106", "SUB R2,R2","107","SUB R2,R3",
                         "108", "SUB R3,R0", "109", "SUB R3,R1", "110", "SUB R3,R2","111","SUB R3,R3",


                         "128","PUSH R0","129","PUSH R1","130","PUSH R2","131","PUSH R3",
                         "132","POP R0","133","POP R1","134","POP R2","135","POP R3",
                         "136","INV R0","137","INV R1","138","INV R2","139","INV R3",
                         "140","CLEAR R0","141","CLEAR R1","142","CLEAR R2","143","CLEAR R3",

                         "148","MOV (R1+),R0", "149", "MOV R0,(R2+)","150", "MOV (R1+),(R2+)", "156", "AND R1,R0", "157","OR R1,R0", "158", "XOR R1,R0",

                         "160","MOV R0,PC", "161", "MOV R0,SP", "162","MOV R0,RI" ,"163", "MOV R0,RE",
                         "164","ENABLE I","165","DISABLE I","166","ENABLE E","167","DISABLE E",
                         "168", "RET","169", "NOP", "170", "STOP",
                         "174","IN (R1),R0","175","OUT R0,(R1)",

                         "176", "INC R0", "177" , "INC R1", "178", "INC R2", "179", "INC R3",
                         "180", "DEC R0", "181" , "DEC R1", "182", "DEC R2", "183", "DEC R3",

                         "999", "END","1000", "#", };

static char *codigoN2[]={ "192","CALL N", "193", "JMP N","194", "JZ N","195", "JNZ N",
                         "196", "JC N", "197", "JNC N", "198","JS N", "199","JNS N",
                         "200", "RL N","201","RR N","202","AND N","203","OR N",
                         "204","XOR N", "205","IN N", "206", "OUT N", "207","CMP N",

                         "208", "MOV N,R0",   "209","MOV N,R1",    "210","MOV N,R2",    "211", "MOV N,R3",
                         "212", "MOV (N),R0", "213", "MOV (N),R1", "214", "MOV (N),R2", "215", "MOV (N),R3",
                         "216", "MOV R0,(N)", "217", "MOV R1,(N)", "218", "MOV R2,(N)", "219", "MOV R3,(N)",
                         "220", "WAIT N",
                         "999", "END","1000", "#", };



char trozo1[20]="";
char trozo2[20]="";
char trozo3[20]="";

unsigned char codigo[256];
int coi;

int parser(int modo);

int tipePrint=0;
int tipePrepo=0;
int tipeBin=0;

int z,zz,z1,z2;
int linea;

char fileOut[20]="file.bin";

int main(int arg,char *argv[])
{
    printf("\nEnsamblador core8 V3_4\n=======================\n");
    if(arg<2)
		{
        printf("ERROR Debes incluir fichero.asm\n");
        printf("Formato:  core8Ensamblador fichero.asm \n");
        printf("\t\t-pt Salida por pantalla\n");
        printf("\t\t-pp Salida por pantalla preprocesador\n");
        printf("\t\t-pb Salida por pantalla binario\n");
        printf("\t\t-o nombre fichero binario\n");
        return(-1);
		}
	for(z=1;z<arg;z++)
     {
      if( !strcmp(argv[z],"-pt"))  { tipePrint=1;}
      if( !strcmp(argv[z],"-pp"))  { tipePrepo=1;}
      if( !strcmp(argv[z],"-pb"))  { tipeBin=1;}
      if( !strcmp(argv[z],"-o"))  { sprintf(fileOut,"%s",argv[z+1]); z++;}
     }
    
// Procesar
    pf=fopen(argv[1] ,"rb");
    if(pf==NULL){ printf("ERROR abriendo fichero %s\n",argv[1]); return(-1);    }

	if(-1==preprocesador(tipePrepo) ){ printf(" ERROR en preprocesador\n"); return(-1);  }  
    fclose(pf);
	  
    pf=fopen("debug.asm","r");
    if(pf==NULL){ printf("ERROR abriendo fichero debug.asm \n"); return(-1);    }   
// Ensamblar    
    nvariables=0;
    z=parser(0);
    if(z==-1) {printError(); goto saltoE;}
    fseek(pf,0,0);
    if(tipePrint==1)
        z=parser(1);	//imprime en pantalla
        else
        z=parser(2);	//no imprime en pantalla
    fclose(pf);  
    if(z==-1) printError();
saltoE:     
    printVariables();   
// Salvar codigo    
    saveCodigo(tipeBin);
    printf("\n");

    return(0);
}
 
// Parser de Ensamblado  _______________________________________
int parser(int modo)
{
    linea=0; coi=0;
    printf("--- Paser %i ===Ensamblador===\n",modo);
    do
    {
		linea++;
        fgets(lineaE,LINEMAX,pf);     
        if(modo==1)   printf("%3d ",linea);
        if(lineaE[0]=='/')  // comentario
            {	
               if(modo==1) printf("%s",lineaE);
                goto salto2;
            }    
            
		z=strlen(lineaE);	//Detecta si la linea esta vacia
        if(z<2) goto salto1;
        lineaE[z-1]=0;
        
        indice=0; etiqueta[0]=0; trozo2[0]=0; trozo3[0]=0;              
        if(lineaE[0]=='$')  //VARIABLES
        {
			 if(modo==1) printf("%s", lineaE);
             for(z=0;z<20;z++,indice++)
                {
					 if(lineaE[indice]<33)
					 {
						etiqueta[z]=0;					
						strcpy(variables[nvariables].nombre,etiqueta);
						indice++;
						variables[nvariables].valor=atoi(lineaE+indice);
						//if(modo==1)  printf("%s",etiqueta);
						if (modo==0)nvariables++;
						goto salto1;
					 }
                 etiqueta[z]=lineaE[indice];
                }
        }
		
		 if(lineaE[0]=='#')    //Variables de salto
					{
						for(z=0;z<20;z++,indice++)
							{
							 if(lineaE[indice]<33)
							 {
								etiqueta[z]=0;
								strcpy(variables[nvariables].nombre,etiqueta);
								indice++;
								if(modo==1)printf("%s DIR=%d ",variables[nvariables].nombre,coi);
								variables[nvariables].valor=coi;
								//if(modo==1)  printf("%s",etiqueta);
								if (modo==0)nvariables++;
								goto salto1;
							 }
							 etiqueta[z]=lineaE[indice];
							}
					}
			
		indice++;
	 for(z=0;z<20;z++,indice++)
        {						
				if(lineaE[indice]<32 || lineaE[indice]=='$' || lineaE[indice]=='#' )
						{	
								  if(indice<2) goto salto1;
								  trozo1[z]=0;									  
								  if(lineaE[indice]=='#' )
									{							  
									  for(zz=0;zz<20;zz++,indice++)
										{
										  trozo2[zz]=lineaE[indice];
										  if(lineaE[indice]<33)
												{
												 trozo2[zz]=0;
												 z2=getValor(trozo2);
												 if(z2==-1 && modo==1) 
													{														
														printError();
														return(-1);
													}
												 break;
												}
										}
									 } 
								  
								  if(lineaE[indice]=='$' )
									{
									  indice++;								  
									  for(zz=0;zz<20;zz++,indice++)
										{
										  trozo2[zz]=lineaE[indice];
										  if(lineaE[indice]<33)
												{
												 trozo2[zz]=0;
												 z2=atoi(trozo2);
												 break;
												}
										}
									 } 
							
								  z1=buscarCode1();
								  if(z1!=-1)
								  {
								   if(z1==999)return(1);
								   if(modo==1)printf("\t\t xx %03d %03d\t\t%9s\t%s",coi,z1,trozo1,lineaE);								   
								   codigo[coi]=z1;  coi++; 								  
								  }
								  else
								  {
									z1=buscarCode2();
									if(z1==-1){  printf("ERROR CODIGO "); return(-1);} 
									if(modo==1) printf("\t\t ## %03d %03d %03d\t\t%9s\t%s",coi,z1,z2,trozo1,lineaE);								
									codigo[coi]=z1;  coi++;  
									codigo[coi]=z2;	coi++;   
								  }
								  goto salto1;							  								  
						}
				trozo1[z]=lineaE[indice];
		}
salto1:
    if(modo==1) printf("\n");
    //printf("***   %03i %s\n",linea,lineaE);
salto2:    
    ;
    } while(feof(pf)==0);
    
    printVariables();

    return(0);
}


int buscarCode2(void)
{
 int z;
 int code;
	  // printf("_________________code 2______________TROZO1=%s__TROZO2=%s*****\n",trozo1,trozo2);
   for(z=0;z<1000;z+=2)
    {
        if( !strcmp(codigoN2[z+1],"#") )     { break;  }
        if( !strcmp(codigoN2[z+1],trozo1) )
            {
             code=atoi(codigoN2[z]);
             return(code)  ;
            }
    }
 return(-1);
}


int buscarCode1(void)
{
 int z;
 int code;
//printf("_________________code 1______________TROZO1=%s__TROZO2=%s*****\n",trozo1,trozo2);
   for(z=0;z<1000;z+=2)
    {
        if( !strcmp(codigoN[z+1],"#") )     { break;  }
        if( !strcmp(codigoN[z+1],trozo1) )
            {
             code=atoi(codigoN[z]);
             return(code)  ;
            }
    }
 return(-1);
}


void printError(void)
{
     printf(" ****ERROR  %03i %s\n",linea-1,lineaE);
}


int getValor(char *nombre)
{
 int z;
      for(z=0;z<VARMAX;z++)
        {
         if(z>=nvariables) break;
         if( !strcmp(nombre,variables[z].nombre) )  return(variables[z].valor);
        }
 return(-1);
}


void printVariables(void)
{
 int z;
    printf("\n==Variables==\n");
    for(z=0;z<VARMAX;z+=3)
        {
         if(z>=nvariables) break;
         printf("%02d-%s=%i\t\t",z,variables[z].nombre,variables[z].valor);
         printf("%02d-%s=%i\t\t",z,variables[z+1].nombre,variables[z+1].valor);
         printf("%02d-%s=%i\n",z,variables[z+2].nombre,variables[z+2].valor);
        }
}


int saveCodigo(int modo)
{
 int z;
 FILE *pfbin;
	 printf("Salvando codigo en fichero %s\n",fileOut);
	 pfbin=fopen(fileOut,"wb");
	 if(pf==NULL){ printf("ERROR abriendo fichero  %s\n",fileOut); return(-1);    }
	 for(z=0;z<256;z++)
		 {
			putc(codigo[z],pfbin);
			if(modo==1)printf("%d,",codigo[z]);
		 }
	 fclose(pfbin);
	 return(0);
}



//__________________________PREPRO___________________________________________
int preprocesador(int modo)
{
	printf("--- Preprocesador ---\n");
	
	pfasm=fopen("debug.asm" ,"w");
    if(pfasm==NULL){ printf("ERROR creando fichero debug.asm \n");  fclose(pf); return(-1);    }
    
	do
	{
		linea++; indice=0;
        fgets(lineaE,LINEMAX,pf);
        lineaE[strlen(lineaE)-1]=0;
        //printf("%s\n",lineaE);
        if( lineaE[0]=='/')
				{
				 if(modo==1) printf("%03d %s\n",linea,lineaE);
				 goto salto;
				}
		for(z=0;z<LINEMAX;z++) { if(lineaE[z]=='/')lineaE[z]=0;  }		
        Mayusculas();
        quitarSPACE();
        quitarFinLinea();
       
        changeSrt(lineaE," ,",",");
        changeSrt(lineaE,", ",",");
      //  printf(">>>>>>>>>>>>>>>>>>>>>>>>>>>>%s<<<<<<<<<<<<<<<\n",lineaE); 
        if(modo==1) printf("%03d %s\n",linea,lineaE);
        
        if(lineaE[0]=='$' )  //VARIABLES
        {
            for(z=0;z<20;z++,indice++)
                {
                 if(lineaE[indice]<33)
                 {
                    etiqueta[z]=0;
                    strcpy(variables[nvariables].nombre,etiqueta);
                    indice++;                    
                    variables[nvariables].valor=atoi(lineaE+indice);                    
                    nvariables++;
                    goto salto;
                 }
                 etiqueta[z]=lineaE[indice];
                }
        }
  //      printf(">>>>>>>>>>>>>x>>>>>>>>>>>>>>%s<<<<<<<<<<<<<<<\n",lineaE); 
        if(lineaE[0]==32) 
			{
				changeVar();
//				printf(">>>>>>>>>>>>>G>>>>>>>>>>>>>>%s<<<<<<<<<<<<<<<\n",lineaE); 
				changeSaltos();
			}  
	//	printf(">>>>>>>>>>>>>y>>>>>>>>>>>>>>%s<<<<<<<<<<<<<<<\n",lineaE);                   
salto:
        fprintf(pfasm,"%s\n",lineaE);
    ;
    } while(feof(pf)==0);   

    fclose(pfasm);
    printf("--- Fin preprocesador ---\n");
    return(0);
}




void changeVar(void)
{
 int z,z2,zz,i,ta;
 char buffer2[30]; 
//Busqueda de variables
		for(z=0;z<VARMAX && z<nvariables;z++)
				{				
					if( 1==changeSrt(lineaE,variables[z].nombre,"N"))
						{
							sprintf(buffer2,"$%03d",variables[z].valor);
							//añade al final el valor numerico
							ta=strlen(lineaE);
							for(i=ta,zz=0;i<LINEMAX ;i++,zz++) 	{ lineaE[i]=buffer2[zz];  if(lineaE[i]==0)break;  }
							return;							
						}
				}
//Busqueda de numeros
		for(z=0;z<40 && lineaE[z]!=0;z++)
		{
		 if(lineaE[z]>47 && lineaE[z]<58)
			{
			 if(lineaE[z-1]==32 || lineaE[z-1]=='(' || lineaE[z-1]==',')
					{
					 z1=z;
					 for(;z<40;z++)
						{
							//printf(" >%d< ",lineaE[z]);
							 if( lineaE[z]<47 || lineaE[z]>58 || lineaE[z]==0 || lineaE[z]==32)	
									{  z2=z;	goto salto;	 }	
						}
					}
			 goto seguir;
			}
seguir:
	;
		}
		return;
salto:	
		//printf(" %s 777 %d 777", buffer2,z2);
		for(z=z1,zz=0;z<z2;z++,zz++)buffer2[zz]=lineaE[z];
		buffer2[zz]=0; ta=atoi(buffer2);
		lineaE[z1]='N'; 
		for(z=z1+1;z<40;z++,z2++)
			{
				lineaE[z]=lineaE[z2];
				if(lineaE[z]<32) break;
			}
		sprintf(lineaEe,"%s$%03d",lineaE,ta);
		strcpy(lineaE,lineaEe);		
}


void changeSaltos(void)
{
 int i,z1,zz;
  
   for(i=3;i<VARMAX;i++)
    {
		if( lineaE[i]=='#')
		{
			for(zz=0,z1=0;zz<VARMAX ;zz++,z1++) 
			{
				if(lineaE[z1]=='#'){ lineaEe[zz]='N'; zz++; }
				lineaEe[zz]=lineaE[z1];
				if(lineaE[z1]==0)break;
			}
			strcpy(lineaE,lineaEe);
            return;
		}
    }
	
}

int changeSrt(char *cadena, char *busqueda, char *cambio)
{
 char *pu;
 int z,zz,i;
 int taBusqueda;
 char bufferS[LINEMAX];
 
		taBusqueda=strlen(busqueda); if(taBusqueda==0) return(0);
		pu=strstr(cadena,busqueda);
		if( pu==NULL )
				{ return(0);}
			else
				{
				 z=pu-cadena;
				 for(i=0;i<LINEMAX && i<z;i++) { bufferS[i]=cadena[i];}
				 for(zz=0;i<LINEMAX ;i++,zz++) {  bufferS[i]=cambio[zz]; if(cambio[zz]==0)break;}
				 z+=taBusqueda;
				 for(;i<LINEMAX ;i++,z++){ bufferS[i]=cadena[z]; if(cadena[z]==0)break; }
				 bufferS[LINEMAX-1]=0;
				 strcpy(cadena,bufferS);	
				}
 return(1);	
}	

int quitarSPACE(void)
{
  int z,z1=0,sp=0;
  unsigned char lineaE1[LINEMAX];

    for (z = 0; z < LINEMAX ; z++)
        {
            lineaE1[z1]=lineaE[z];          
            if(lineaE[z]==32)
                sp++;
              else
                sp=0;
            if(sp<2 ) z1++;
            if(lineaE[z]==0)break;
        }
    for (z=0;z<LINEMAX;z++)
        {
           lineaE[z]=lineaE1[z];
           if(lineaE[z]==0)break;
        }
 return 0;
}


//todo Mayusculas y quitar caracteres menores de 32
int Mayusculas(void)
{
  int z;
     for (z = 0; z < LINEMAX && lineaE[z]!=0 ; z++)
        {
         if (lineaE[z] > 96 && lineaE[z] < 123) lineaE[z] -= 32; //mayusculas
         if (lineaE[z] < 32 ) lineaE[z] = 32;
        }
  return 0;
}



//quitarFinLinea
int quitarFinLinea(void)
{
 int z,z1=0;
  unsigned char lineaE1[LINEMAX];
    for (z = 0; z < LINEMAX ; z++,z1++)
        {
            lineaE1[z1]=lineaE[z];
            if(lineaE[z]==0)
            {
				if(z>0 && lineaE[z-1]==32) lineaE1[z-1]=0;
				break;
			}
        }
    for (z=0;z<LINEMAX;z++)
        {
           lineaE[z]=lineaE1[z];
           if(lineaE[z]==0)break;
        }
 return 0;
}

